package com.unitech.util;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.os.Environment;

/**
 * Created by USER
 */
public class KeyAPI {
    public final static String PKG_NAME = "com.android.settings";
    public final static String CLS_NAME_EXPORT = "com.android.settings.ProgrammableKeyExport";
    private final static String CLS_NAME_IMPORT = "com.android.settings.ProgrammableKeyImport";
    private final static String CLS_NAME_RESET = "com.android.settings.ProgrammableKeyReset";
    /**
     * The path of folder api import and export
     */
    public final static String EXTRA_FILE_PATH = "filepath";
    public final static String DEFAULT_FOLDER_PATH = String.format("%s/unitech/KeySharp/", Environment.getExternalStorageDirectory().getPath());
    public final static String FILEPATH_KEYS_CONFIG = String.format("%skeys_config.txt", DEFAULT_FOLDER_PATH);
    public final static String FILEPATH_DEFAULT_KEYCODES = String.format("%sdefault_keycodes.txt", DEFAULT_FOLDER_PATH);

    public static void importSettings(Activity activity, int requestCode) {
        importSettings(activity, null, requestCode);
    }

    public static void importSettings(Context context, String pathFolder) {
        Intent intent = new Intent();
        ComponentName componentName = new ComponentName(PKG_NAME, CLS_NAME_IMPORT);
        intent.setComponent(componentName);
        if (pathFolder != null && pathFolder.length() > 0) {
            intent.putExtra(EXTRA_FILE_PATH, pathFolder);
        }
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(intent);
    }

    public static void importSettings(Activity activity, String pathFolder, int requestCode) {
        Intent intent = new Intent();
        ComponentName componentName = new ComponentName(PKG_NAME, CLS_NAME_IMPORT);
        intent.setComponent(componentName);
        if (pathFolder != null && pathFolder.length() > 0) {
            intent.putExtra(EXTRA_FILE_PATH, pathFolder);
        }
        activity.startActivityForResult(intent, requestCode);
    }

    public static void exportSettings(Activity activity, int requestCode) {
        exportSettings(activity, null, requestCode);
    }

    public static void exportSettings(Context context, String pathFolder) {
        Intent intent = new Intent();
        ComponentName componentName = new ComponentName(PKG_NAME, CLS_NAME_EXPORT);
        intent.setComponent(componentName);
        if (pathFolder != null && pathFolder.length() > 0) {
            intent.putExtra(EXTRA_FILE_PATH, pathFolder);
        }
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(intent);
    }

    public static void exportSettings(Activity activity, String pathFolder, int requestCode) {
        Intent intent = new Intent();
        ComponentName componentName = new ComponentName(PKG_NAME, CLS_NAME_EXPORT);
        intent.setComponent(componentName);
        if (pathFolder != null && pathFolder.length() > 0) {
            intent.putExtra(EXTRA_FILE_PATH, pathFolder);
        }
//        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        activity.startActivityForResult(intent, requestCode);
    }

    public static void resetSettings(Activity activity, int requestCode) {
        Intent intent = new Intent();
        ComponentName componentName = new ComponentName(PKG_NAME, CLS_NAME_RESET);
        intent.setComponent(componentName);
        activity.startActivityForResult(intent, requestCode);
    }
}
